;; ---------------------------------------------------------------------
;; Hook for the keyboard
;; ---------------------------------------------------------------------

WM_KEYDOWN = 100h
WM_KEYUP   = 101h
VK_CTRL    = 1D11h
VK_ESC     = 011Bh

.model large, C

.data

;--- BOOL: is the Ctrl key down ? ---
ControlA db  0

.code
.386p
locals

public C EventHook
extrn  C SETRTASK : far

EventHook proc far

    push  ds
    pusha

    mov   bx,@data
    mov   ds,bx
    cmp   ax, WM_KEYDOWN
    je    @@KeyDown

    cmp   ax, WM_KEYUP
    je    @@KeyUp

    jmp   @@Next

@@KeyUp:
    cmp   cx, VK_CTRL  ; did we release Ctrl key ?
    jne   @@Next
    
    Mov   ControlA, 0  ; Yes. deactivate the signal
    jmp   @@Next

@@KeyDown:
    cmp   cx, VK_CTRL  ; cmp key to VK_CTRL
    je    @@Control

    cmp   cx, VK_ESC   ; cmp key to VK_ESC
    je    @@Esc
    jmp   @@Next

@@Esc:
    cmp   ControlA, 0  ; if (!Ctrl) then exit
    je    @@Next

    push  1
    call  SETRTASK     ; tell to Speedm to run the Task Manager
    add   sp,2         ; clean the stack
    popa               ; when the next tick occurs
    pop   ds
    mov   cx,0000h     ; clear the key to avoid windows to run TaskMan.
    ret

@@Control:
    mov   ControlA, 1  ; Ctrl down so flag it
    
@@Next:
    popa
    pop   ds
    ret
endp

end
